// headerfile for the application

/* position of the parameter stack */
#pragma stack 0x380 0x60


/*
 * Definitions and functions of the coreboard and the processor.
 * If you want to use another coreboard, set it in coreboard.h
 * AND modify the Makefile. Do NOT include the boardfile
 * (like board229.h) directly instead of coreboard.h, otherwise
 * your stack may be compiled for a wrong hardware.
 */
#include <coreboard.h>

/* 
 * Definitions and functions of the sensorboard and the sensors used.
 * If you want another sensorboard or use different sensors, set it
 * in sensorboard.h. If you do not want to use sensors, remove this
 * include AND modify the Makefile.
*/
//#include <sensorboard.h>

/* Awarecon stack (includes rf, ll, acl, app) */
#include <communication.h>
/*
 * Optional stuff (like sdjs or ack) that affect the stack can be
 * found in optional.h. It is already included in communication.h and
 * you do not have to include it here, but remember to enable the modules
 * in the "STACKOPTIONS =" line in the Makefile.
 */



/* 
 * Code that does not affect the stack may be included here like RTC. 
 * Remember to set the corresponding "OPTIONS =" line in the Makefile.
 */
#include <rtc.h>


/* these are the configuration words */
code char at __CONFIG1H config1h = 0xFF  & _OSC_HS_1H;
code char at __CONFIG2H config2h = 0xFF  & _WDT_OFF_2H;
code char at __CONFIG2L config2l = 0xFF  & _PUT_ON_2L & _BODEN_OFF_2L;
code char at __CONFIG4L config4l = 0xFF  & _LVP_OFF_4L;
