/**
  * Copyright (c) 2004, Telecooperation Office (TecO),
  * Universitaet Karlsruhe (TH), Germany.
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  *
  *   * Redistributions of source code must retain the above copyright
  *     notice, this list of conditions and the following disclaimer.
  *   * Redistributions in binary form must reproduce the above
  *     copyright notice, this list of conditions and the following
  *     disclaimer in the documentation and/or other materials provided
  *     with the distribution.
  *   * Neither the name of the Universitaet Karlsruhe (TH) nor the names
  *     of its contributors may be used to endorse or promote products
  *     derived from this software without specific prior written
  *     permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **/

#ifndef __18F6720_H__
#define __18F6720_H__

// ensures aquisition time
#define SAVETIMINGS

// TECO Michael Beigl Oct 2003

// Header file for pic 18F6x2x
//
// containing the registers for the pic


// Hardware Adresses

#define PROCESSOR_TYPE	186720

#define PIC_TMR4	TMR4
#define PIC_PR4	PR4
#define PIC_T4CON	T4CON
#define PIC_CCPR4H	CCPR4H
#define PIC_CCP4CON	CCP4CON
#define PIC_CCPR5H	CCPR5H
#define PIC_CCPR5L	CCPR5L
#define PIC_CCP5CON	CCP5CON
#define PIC_SPBRG2	SPBRG2
#define PIC_RCREG2	RCREG2
#define PIC_TXREG2	TXREG2
#define PIC_TXSTA2	TXSTA2
#define PIC_RCSTA2	RCSTA2

#define PIC_PORTA	PORTA
#define PIC_PORTB	PORTB
#define PIC_PORTC	PORTC
#define PIC_PORTD	PORTD
#define PIC_PORTE	PORTE
#define PIC_PORTF	PORTF
#define PIC_PORTG	PORTG
#define PIC_LATA	LATA
#define PIC_LATB	LATB
#define PIC_LATC	LATC
#define PIC_LATD	LATD
#define PIC_LATE	LATE
#define PIC_TRISA	TRISA
#define PIC_TRISB	TRISB
#define PIC_TRISC	TRISC
#define PIC_TRISD	TRISD
#define PIC_TRISE	TRISE
#define PIC_TRISF	TRISF
#define PIC_TRISG	TRISG

#define PIC_PIE1	PIE1
#define PIC_PIR1	PIR1
#define PIC_IPR1	IPR1
#define PIC_PIE2	PIE2
#define PIC_PIR2	PIR2
#define PIC_IPR2	IPR2
#define PIC_PIE3	PIE3
#define PIC_PIR3	PIR3
#define PIC_IPR3	IPR3

#define PIC_EECON1	EECON1
#define PIC_EECON2	EECON2
#define PIC_EEDATA	EEDATA
#define PIC_EEADR	EEADR

#define PIC_RCSTA1	RCSTA1
#define PIC_TXSTA1	TXSTA1
#define PIC_TXREG1	TXREG1
#define PIC_RCREG1	RCREG1
#define PIC_SPBRG1	SPBRG1

#define PIC_T3CON	T3CON
#define PIC_TMR3L	TMR3L
#define PIC_TMR3H	TMR3H

#define PIC_CCP2CON	CCP2CON
#define PIC_CCPR2L	CCPR2L
#define PIC_CCPR2H	CCPR2H
#define PIC_CCP1CON	CCP1CON
#define PIC_CCPR1L	CCPR1L
#define PIC_CCPR1H	CCPR1H

#define PIC_ADCON2	ADCON2
#define PIC_ADCON1	ADCON1
#define PIC_ADCON0	ADCON0
#define PIC_ADRESL	ADRESL
#define PIC_ADRESH	ADRESH
#define PIC_SSPCON2	SSPCON2
#define PIC_SSPCON1	SSPCON1
#define PIC_SSPSTAT	SSPSTAT
#define PIC_SSPADD	SSPADD
#define PIC_SSPBUF	SSPBUF
#define PIC_T2CON	T2CON
#define PIC_PR2	PR2
#define PIC_TMR2	TMR2
#define PIC_T1CON	T1CON
#define PIC_TMR1L	TMR1L
#define PIC_TMR1H	TMR1H
#define PIC_RCON	RCON
#define PIC_WDTCON	WDTCON
#define PIC_LVDCON	LVDCON
#define PIC_OSCCON	OSCCON
#define PIC_T0CON	T0CON
#define PIC_TMR0L	TMR0L
#define PIC_TMR0H	TMR0H
#define PIC_STATUS	STATUS
#define PIC_FSR2L	FSR2L
#define PIC_FSR2H	FSR2H
#define PIC_PLUSW2	PLUSW2
#define PIC_PREINC2	PREINC2
#define PIC_POSTDEC2	POSTDEC2
#define PIC_POSTINC2	POSTINC2
#define PIC_INDF2	INDF2
#define PIC_BSR	BSR
#define PIC_FSR1L	FSR1L
#define PIC_FSR1H	FSR1H
#define PIC_PLUSW1	PLUSW1
#define PIC_PREINC1	PREINC1
#define PIC_POSTDEC1	POSTDEC1
#define PIC_POSTINC1	POSTINC1
#define PIC_INDF1	INDF1
#define PIC_WREG	WREG
#define PIC_FSR0L	FSR0L
#define PIC_FSR0H	FSR0H
#define PIC_PLUSW0	PLUSW0
#define PIC_PREINC0	PREINC0
#define PIC_POSTDEC0	POSTDEC0
#define PIC_POSTINC0	POSTINC0
#define PIC_INDF0	INDF0
#define PIC_INTCON3	INTCON3
#define PIC_INTCON2	INTCON2
#define PIC_INCON	INTCON
#define PIC_PRODL	PRODL
#define PIC_PRODH	PRODH
#define PIC_TABLAT	TABLAT
#define PIC_TBLPTRL	TBLPTRL
#define PIC_TBLPTRH	TBLPTRH
#define PIC_TBLPTRU	TBLPTRU
#define PIC_PCL	PCL
#define PIC_PCLATH	PCLATH
#define PIC_PCLATU	PCLATU
#define PIC_STKPTR	STKPTR
#define PIC_TOSL	TOSL
#define PIC_TOSH	TOSH
#define PIC_TOSU	TOSU




//for EEPROM access
//#define EEADR 				0xFA9
//#define EEDATA 				0xFA8
//#define EECON1 				0xFA6
#define RD 					0
#define WR 					1
#define WREN 				2
#define WRERR 				3
#define FREE 				4
#define CFGS 				6
#define EEPGD 				7
//#define EECON2 				0xFA7
//#define PIR2 				0xFA1
#define EEIF 				4


#define ADCH_PIN_A0					 0x00
#define ADCH_PIN_A1					 0x01
#define ADCH_PIN_A2                  0x02
#define ADCH_PIN_A3                  0x03
#define ADCH_PIN_A5                  0x04
#define ADCH_PIN_F0                  0x05




#define PIN_0_ON	_asm   bsf _PORTB,0 _endasm;
#define PIN_0_OFF   _asm   bcf _PORTB,0 _endasm;
#define PIN_1_ON	_asm   bsf _PORTB,1 _endasm;
#define PIN_1_OFF   _asm   bcf _PORTB,1 _endasm;
#define PIN_2_ON	_asm   bsf _PORTB,2 _endasm;
#define PIN_2_OFF   _asm   bcf _PORTB,2 _endasm;
#define PIN_3_ON	_asm   bsf _PORTB,3 _endasm;
#define PIN_3_OFF   _asm   bcf _PORTB,3 _endasm;
#define PIN_4_ON	_asm   bsf _PORTB,4 _endasm;
#define PIN_4_OFF   _asm   bcf _PORTB,4 _endasm;
#define PIN_5_ON	_asm   bsf _PORTB,5 _endasm;
#define PIN_5_OFF   _asm   bcf _PORTB,5 _endasm;
#define PIN_6_ON	_asm   bsf _PORTB,6 _endasm;
#define PIN_6_OFF   _asm   bcf _PORTB,6 _endasm;
#define PIN_7_ON	_asm   bsf _PORTB,7 _endasm;
#define PIN_7_OFF   _asm   bcf _PORTB,7 _endasm;


//for RF; 18f6720
#define RF_TXSTA			PIC_TXSTA2
#define RF_SPBRG			PIC_SPBRG2
#define RF_RCREG			PIC_RCREG2
#define RF_RCSTA			PIC_RCSTA2
#define RF_UART_SREN		PIC_RCSTA2,5
#define RF_UART_CREN		PIC_RCSTA2,4
#define RF_UART_RCIF		PIC_PIR3,5
#define RF_UART_SPEN		PIC_RCSTA2,7

#define RF_SSPBUF			PIC_SSPBUF
#define RF_SSPSTAT_BF		PIC_SSPSTAT,0
#define RF_TIMER1_IF		PIC_PIR1,0
#define RF_TIMER1_CON		PIC_T1CON
#define RF_TIMER2_TMR2IF	PIC_PIR1,1

#define RF_TIMER1H			PIC_TMR1H
#define RF_TIMER1L			PIC_TMR1L
#define RF_TIMER2			PIC_TMR2

#define RF_SSPCON_SSPEN		PIC_SSPCON1,5






#undef set_mode_A
#define set_mode_A(input, pin) portmode_fast(A, input, pin) 
#undef set_mode_B
#define set_mode_B(input, pin) portmode_fast(B, input, pin) 
#undef set_mode_C
#define set_mode_C(input, pin) portmode_fast(C, input, pin) 
#undef set_mode_D
#define set_mode_D(input, pin) portmode_fast(D, input, pin) 
#undef set_mode_E
#define set_mode_E(input, pin) portmode_fast(E, input, pin) 
#undef set_mode_F
#define set_mode_F(input, pin) portmode_fast(F, input, pin) 
#undef set_mode_G
#define set_mode_G(input, pin) portmode_fast(G, input, pin) 



/* *****************************************************
 * Prototypes and typedefs
 * *****************************************************
 */

void DelayMs(uint16_t Minizekunden) wparam;
void DelayUs( uint8_t muesekunden ) wparam;
void DelayUsLong( uint16_t muesekunden ) wparam;


// to make DelayUs as independent as possible from ccs compiler........
extern uint8_t at 0x53 mue_hi;
extern uint8_t at 0x54 mue_lo;


#ifndef __LOADER_ONLY__
// all other
void WriteIntEeprom(uint8_t address, uint8_t __PIC_data) wparam;
uint8_t ReadIntEeprom(uint8_t address) wparam;
#endif // __LOADER_ONLY__


#define hi(x)  (*(((char *)&x)+1))
#define lo(x)  (*((char *)&x))
#define EEPROM_ADDRESS_ID			0		// start addresss for ID in internal EEPROM


enum serial_speed{SERIAL_625000,SERIAL_19200};
typedef enum serial_speed serial_speed;
enum serial_mode{SERIAL_ASYNCHRONOUS,SERIAL_SYNCHRONOUS};
typedef enum serial_mode serial_mode;


enum timer_config{CLOCK_32kHz,AWARECON_SLOT_TIMER,AWARECON_BIT_TIMER};
typedef enum timer_config timer_config;

enum analog_config
{
	NONE,
	AN0,
	AN0_AN1,
	AN0_AN1_AN2,
	AN0_AN1_AN2_AN3,
	AN0_AN1_AN2_AN3_AN4,
	AN0_AN1_AN2_AN3_AN4_AN5
};
typedef enum analog_config analog_config;



//----------------------------------------------------
// the spi
//only master modes are supported

enum SPI_MODE{SPI_MODE_TIMER2,SPI_MODE_FAST};
typedef enum SPI_MODE SPI_MODE;

void SPISetMode(SPI_MODE mode) wparam;
void SPIInit(SPI_MODE mode) wparam;

// shifts one byte out and the rx in at the same time (typical spi process)
uint8_t SPIShift(uint8_t out) wparam;

#ifndef __LOADER_ONLY__

/**
* Enables the A/D converter
*/
void ADCEnable();

/**
* Checks whether the given channel is already set for
* A/D conversion.
* @param channel channel to check
* @return true if channel is already set
*/
uint8_t ADCIsChSet(uint8_t channel) wparam;

/**
* Sets a given channel for A/D conversion
* @param channel channel for conversion
*/
void ADCSetCh(uint8_t channel) wparam;

/**
* Sets the sampling speed for A/D conversion
* @param speed sampling rate
*
* Note: the parameter is currently ignored. The sampling speed is set to maximum
* for 18f6620 at 20 MHz
*/
void ADCSetClock(uint8_t speed) wparam;

/**
* Reads a sampled value from the A/D converter. Only one byte.
* @return sampled value as byte
*/
uint8_t ADCRead8();

/**
* Reads a sampled value from the A/D converter. Full 10bit of the ADC
* @return sampled value as uint16_t, where the bit 3-7 are set to 0.
*/
uint16_t ADCRead10();


/**
* Initialises the A/D converter
* Set some reasonable values
*/
void ADCInit();

/**
* Disables the A/D converter
*/
void ADCDisable();

void ADCConfig(analog_config conf) wparam;

void ADCEnable();

uint8_t ADCIsChSet(uint8_t channel) wparam;

void ADCSetCh(uint8_t channel) wparam;




uint8_t Uart1WaitForRx(uint16_t wait_time) wparam;
void Uart1Enable();
void Uart1Disable();
void Uart1Init(serial_speed speed, serial_mode sync_mode, uint8_t bits) wparam;
uint8_t Uart1CheckError();
void Uart1FlushReceive();
void Uart1WaitForTxEnd();
uint8_t Uart1DataIsThere();
void Uart1SendByte(uint8_t __PIC_data) wparam;
uint8_t Uart1GetByte();


void Timer3Init(timer_config conf) wparam;
uint8_t Timer3GetHi();
uint8_t Timer3GetLo();
void Timer3SetHi(uint8_t val) wparam;
void Timer3SetLo(uint8_t val) wparam;

#endif // __LOADER_ONLY__



#endif // __18F6720_H__
