/**
  * Copyright (c) 2004, Telecooperation Office (TecO),
  * Universitaet Karlsruhe (TH), Germany.
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  *
  *   * Redistributions of source code must retain the above copyright
  *     notice, this list of conditions and the following disclaimer.
  *   * Redistributions in binary form must reproduce the above
  *     copyright notice, this list of conditions and the following
  *     disclaimer in the documentation and/or other materials provided
  *     with the distribution.
  *   * Neither the name of the Universitaet Karlsruhe (TH) nor the names
  *     of its contributors may be used to endorse or promote products
  *     derived from this software without specific prior written
  *     permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **/

/**
*
*	Boardheaderfile fr 229
*
*
* file version: 001 (2004-11-03, sabin)

*				includes production id.
*
*
* Date:
*  2005_02_01 Daniel & Raphael
*  new Particle Base System organization
*
**/



#ifndef __BOARD229_H__
#define	__BOARD229_H__					001


#include <tools.h>

#include "18f6720.h"

/*
 * for more includes (buzzer etc.) look at the end of this file
 */

#define 	PRODUCTION_ID_HI		10
#define		PRODUCTION_ID_LO		2


// this is for delay.c (included in board229.c)
#define CLOCK_SPEED 20000000



// pins for RF module
#define PIN_RF_CTR0 		PIN_F5
#define TRIS_RF_CTR0		PIC_TRISF,5
#define PIN_RF_CTR1 		PIN_G4
#define TRIS_RF_CTR1 		PIC_TRISG,4
#define PIN_RF_TX   		PIN_C5			// SPI Out
#define TRIS_RF_TX			PIC_TRISC,5
#define PIN_RF_RX  			PIN_G2			// Data Line of Usart in Synchronous Mode
#define TRIS_RF_RX			PIC_TRISG,2
#define PIN_RF_POWER		PIN_D2
#define TRIS_RF_POWER		PIC_TRISD,2
#define PIN_RF_SENSITIVE 	PIN_D1
#define TRIS_RF_SENSITIVE	PIC_TRISD,1


// pins for RF poti
#define PIN_POTI_POWER		PIN_G3  //
#define TRIS_POTI_POWER		PIC_TRISG,3
#define PIN_POTI_UD			PIN_E0
#define TRIS_POTI_UD		PIC_TRISE,0
#define PIN_POTI_INC		PIN_G0
#define TRIS_POTI_INC		PIC_TRISG,0


// pins for LEDs
#define LED_PC_RED			PIN_C2
#define LED_PC_BLUE			PIN_F6
#define RED					LED_PC_RED			//for convenience
#define BLUE				LED_PC_BLUE


//pins for pc i2c (eeprom etc)
#define PIN_I2C_PC_SDA		PIN_C5
#define TRIS_I2C_PC_SDA		PIC_TRISC,5
#define PIN_I2C_PC_SCL		PIN_C3
#define TRIS_I2C_PC_SCL		PIC_TRISC,3
#define	PIN_I2C_PC_POWER	PIN_D7
#define	TRIS_I2C_PC_POWER	PIC_TRISD,7

#define	XROM_ID				0

// pins for pc sensors
#define PIN_VOLTAGE			PIN_A0
#define ADCH_VOLTAGE		ADCH_PIN_A0
#define PIN_RSSI			PIN_A1
#define ADCH_RSSI			ADCH_PIN_A1



// pins for the spi flash module
#define PIN_FLASH_POWER	    PIN_D7
#define TRIS_FLASH_POWER	PIC_TRISD,7
#define PIN_FLASH_CS		PIN_D3
#define TRIS_FLASH_CS		PIC_TRISD,3


//pins for the flash as well (not used?)
#define PIN_FLASH_SI		PIN_C5
#define TRIS_FLASH_SI		PIC_TRISC,5
#define PIN_FLASH_SO		PIN_C4
#define TRIS_FLASH_SO		PIC_TRISC,4
#define PIC_FLASH_SCK		PIN_C3
#define TRIS_FLASH_SCK		PIC_TRISC,3


//pins for the buzzer
#define TRIS_BUZZER			PIC_TRISE,3
#define PIN_BUZZER			PIN_E3


//pins for the 1-wire ID chip
#define TRIS_ID_CHIP_DATA	PIC_TRISE,7
#define PIN_ID_CHIP_DATA	PIN_E7
#define PIN_ID_CHIP_POWER	PIN_E6
#define TRIS_ID_CHIP_POWER	PIC_TRISE,6


//pins for the ballswitch

#define TRIS_BALL_INNER		PIC_TRISD,0
#define PIN_BALL_INNER		PIN_D0
#define PIN_BALL_OUTER		PIN_B0
#define TRIS_BALL_OUTER		PIC_TRISB,0


//connectors defines for conan
#define PIN_CONN_01                             // VCC
#define PIN_CONN_02                             PIN_B0
#define PIN_CONN_03                             PIN_B1
#define PIN_CONN_04                             PIN_B2
#define PIN_CONN_05                             PIN_B3
#define PIN_CONN_06                             PIN_B4
#define PIN_CONN_07                             PIN_B5
#define PIN_CONN_08                             PIN_B6
#define PIN_CONN_09                             PIN_B7
#define PIN_CONN_10                             // MCLR
#define PIN_CONN_11                             PIN_A2
#define PIN_CONN_12                             PIN_A3
#define PIN_CONN_13                             PIN_F0
#define PIN_CONN_14                             PIN_A5
#define PIN_CONN_15                             PIN_E4
#define PIN_CONN_16                             PIN_E5
#define PIN_CONN_17                             PIN_D4
#define PIN_CONN_18                             PIN_D5
#define PIN_CONN_19                             PIN_C6
#define PIN_CONN_20                             PIN_C7
#define PIN_CONN_21                             // GND

#define TRIS_CONN_01                    // VCC
#define TRIS_CONN_02                    PIC_TRISB,0
#define TRIS_CONN_03                    PIC_TRISB,1
#define TRIS_CONN_04                    PIC_TRISB,2
#define TRIS_CONN_05                    PIC_TRISB,3
#define TRIS_CONN_06                    PIC_TRISB,4
#define TRIS_CONN_07                    PIC_TRISB,5
#define TRIS_CONN_08                    PIC_TRISB,6
#define TRIS_CONN_09                    PIC_TRISB,7
#define TRIS_CONN_10                    // MCLR
#define TRIS_CONN_11                    PIC_TRISA,2
#define TRIS_CONN_12                    PIC_TRISA,3
#define TRIS_CONN_13                    PIC_TRISF,0
#define TRIS_CONN_14                    PIC_TRISA,5
#define TRIS_CONN_15                    PIC_TRISE,4
#define TRIS_CONN_16                    PIC_TRISE,5
#define TRIS_CONN_17                    PIC_TRISD,4
#define TRIS_CONN_18                    PIC_TRISD,5
#define TRIS_CONN_19                    PIC_TRISC,6
#define TRIS_CONN_20                    PIC_TRISC,7
#define TRIS_CONN_21                    // GND

#define ADCH_CONN_11                    ADCH_PIN_A2
#define ADCH_CONN_12                    ADCH_PIN_A3
#define ADCH_CONN_13                    ADCH_PIN_F0
#define ADCH_CONN_14                    ADCH_PIN_A5


//for RPC SERVER
#define TRIS_RPC_HANDSHAKE_SERVER		TRIS_CONN_04
#define PIN_RPC_HANDSHAKE_SERVER		PIN_CONN_04



/* *****************************************************
 * Prototypes and typedefs
 * *****************************************************
 */


enum analog_settings {ANALOG_ALL_DIGITAL,ANALOG_CONN_11,ANALOG_CONN_11_12,ANALOG_CONN_11_12_14,ANALOG_CONN_11_12_13_14};
typedef enum analog_settings analog_settings;

enum port_settings {NORMAL,SELFTEST,ALLIN};
typedef enum port_settings port_settings;

/**
* reflects the possible states for a digital pin
*/
//enum pinstate {low, high, in};
typedef enum pinstate pinstate;

#define PCLedRedOn() output_high(RED)

#define PCLedBlueOn() output_high(BLUE)

#define PCLedRedOff() output_low(RED)

#define PCLedBlueOff() output_low(BLUE)


#ifndef __LOADER_ONLY__

void PCInit();
uint8_t PCGetID(uint8_t * p_id) wparam;
uint8_t PCSetDigitalPorts(port_settings choice) wparam;
uint8_t PCSelfTestBoardIsThere();
uint8_t PCSelfTest(uint8_t * result) wparam;

/* functions in delay.c, included in board229.c */
void delay_us(unsigned int us) wparam;
void delay_ms(unsigned int ms) wparam;

/**
* Sets the analog pins.
* AN0 and AN1 are always set to analog
*
* 0: AN2..AN5 are digital
* 1: AN2 is analog, AN3..AN5 are digital
* 2: AN2..AN3 are analog, AN4..AN5 are digital
* 3: AN2..AN4 are analog, AN5 is digital
* 4: AN2..AN5 are analog
*
* @param config config byte (one of [0..4])
*/
void PCSetAnalogPorts(analog_settings config) wparam;
uint8_t PCSetDigitalPorts(port_settings choice) wparam;

//Attention: this function sets tris to different values
uint8_t PCSelfTestBoardIsThere();

//return value 0: no selftest board found, 1: selftest board is there
//
//  uint8_t*result: a 10 byte array is expected
uint8_t PCSelfTest(uint8_t * result) wparam;

/// for RPC Server:: match UART to RPC
uint8_t RPCServerSerialWaitForRx(uint16_t wait_time) wparam;
void RPCServerSerialEnable();
void RPCServerSerialDisable();
void RPCServerSerialInit(serial_speed speed, serial_mode sync_mode, uint8_t bits) wparam;
uint8_t RPCServerSerialCheckError();
void RPCServerSerialFlushReceive();
void RPCServerSerialWaitForTxEnd();
uint8_t RPCServerSerialDataIsThere();
void RPCServerSerialSendByte(uint8_t __PIC_data) wparam;
uint8_t RPCServerSerialGetByte();

void ClockTimerInit(timer_config conf) wparam;
uint8_t ClockTimerGetHi();
uint8_t ClockTimerGetLo();
void ClockTimerSetHi(uint8_t val) wparam;
void ClockTimerSetLo(uint8_t val) wparam;


/*
 *
 *	Power RF Module
 *
 */
void RFPowerModuleOn();
void RFPowerModuleOff();



/*
 * some attached devices
 */

#include "owmb.h"
#include "ds2431.h"
#include "ballswitch.h"



#endif // __LOADER_ONLY__





#endif // __BOARD229_H__
