/**
  * Copyright (c) 2004, Telecooperation Office (TecO),
  * Universitaet Karlsruhe (TH), Germany.
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  *
  *   * Redistributions of source code must retain the above copyright
  *     notice, this list of conditions and the following disclaimer.
  *   * Redistributions in binary form must reproduce the above
  *     copyright notice, this list of conditions and the following
  *     disclaimer in the documentation and/or other materials provided
  *     with the distribution.
  *   * Neither the name of the Universitaet Karlsruhe (TH) nor the names
  *     of its contributors may be used to endorse or promote products
  *     derived from this software without specific prior written
  *     permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **/

#ifndef __OWMB_H__
#define __OWMB_H__
/**
* driver for magnetic buzzer owmb 505025
* MAKE SURE THAT NO INTERRUPTS OCCURR DURING BUZZERS!!!!
*
*
* Author: Albert Krohn krohn@teco.edu
* Date: 2004-07-30 (yyyy-mm-dd)
*
* Current state: ok
*
* version 001: 	2004-11-10 by sabin (wendhack@teco.edu)
*
*
* Date:
*  2005_02_01 Daniel & Raphael
*  new Particle Base System organization
*
*
*/

#include <tools.h>


#define BUZZER_MODULE	001

#define TONE_C3		130
#define TONE_D3		146
#define TONE_E3		164
#define TONE_F3		174
#define TONE_G3		196
#define TONE_A3		220
#define TONE_H3		246

#define TONE_C4		261
#define TONE_D4		293
#define TONE_E4		329
#define TONE_F4		349
#define TONE_G4		392
#define TONE_A4		440
#define TONE_H4		493

#define TONE_C5		523
#define TONE_D5		587
#define TONE_E5		659
#define TONE_F5		698
#define TONE_G5		783
#define TONE_A5		880
#define TONE_H5		987

#define TONE_C6		1046
#define TONE_D6		1174
#define TONE_E6		1318
#define TONE_F6		1396
#define TONE_G6		1567
#define TONE_A6		1760
#define TONE_H6		1975

#define TONE_C7		2093
#define TONE_D7		2349
#define TONE_E7		2637
#define TONE_F7		2793
#define TONE_G7		3135
#define TONE_A7		3520
#define TONE_H7		3951

#define TONE_C8		4186
#define TONE_D8		4700
#define TONE_E8		5280
#define TONE_F8		5586
#define TONE_G8		6270
#define TONE_A8		7040
#define TONE_H8		7900

#define TONE_C9		8370

/**
* Switches the micro amp off
*/


void BuzzerOff();
void BuzzerSetVolume(uint8_t vol) wparam;
uint8_t BuzzerGetVolume();

uint8_t BuzzerInit();
void BuzzerTone(uint16_t frequency,uint16_t duration) wparam;
void BuzzerSweepUp();
void BuzzerSweepDown();
void BuzzerPlayASong(uint8_t song) wparam;

#endif // __OWMB_H__
