/**
  * Copyright (c) 2004, Telecooperation Office (TecO),
  * Universitaet Karlsruhe (TH), Germany.
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  *
  *   * Redistributions of source code must retain the above copyright
  *     notice, this list of conditions and the following disclaimer.
  *   * Redistributions in binary form must reproduce the above
  *     copyright notice, this list of conditions and the following
  *     disclaimer in the documentation and/or other materials provided
  *     with the distribution.
  *   * Neither the name of the Universitaet Karlsruhe (TH) nor the names
  *     of its contributors may be used to endorse or promote products
  *     derived from this software without specific prior written
  *     permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **/


/*
 *
 * Date:
 *  2005_02_01 Daniel & Raphael
 *  new Particle Base System organization
 *
 */


// new i2c_pc
// defines must be set in pc202.c

#include "pci2c.h"
#include "coreboard.h"

void PCI2CInit()
{
	bit_set(TRIS_I2C_PC_SDA);		//set data input
	bit_set(TRIS_I2C_PC_SCL);		//set clock to input
	bit_clear(TRIS_I2C_PC_POWER);	//set power to output
	output_high(PIN_I2C_PC_POWER);		//set default: on!
}

void PCI2COn()
{
	output_high(PIN_I2C_PC_POWER);
}

void PCI2COff()
{
	output_low(PIN_I2C_PC_POWER);
}






#undef I2C_SCL
#undef I2C_SDA
#undef I2C_SUFFIX
#define I2C_SCL   	PIN_I2C_PC_SCL
#define I2C_SDA   	PIN_I2C_PC_SDA
#define I2C_SUFFIX	_PIN_I2C_PC_SDA_PIN_I2C_PC_SCL
#include <software_i2c.c>
void PCI2CStart()
{
	bit_set(TRIS_I2C_PC_SDA);		//set data input
	bit_set(TRIS_I2C_PC_SCL);		//set clock to input

	
	i2c_start();

}


uint8_t PCI2CWrite(uint8_t __PIC_data) wparam
{
	
	return i2c_write(__PIC_data);
}



uint8_t PCI2CRead(uint8_t __PIC_data) wparam
{
	
	return i2c_read(__PIC_data);
}


void PCI2CStop()
{
	
	i2c_stop();
	bit_clear(TRIS_I2C_PC_SDA);		//set data output, since RF_TX == I2C_PC_SDA
}



