/**
  * Copyright (c) 2004, Telecooperation Office (TecO),
  * Universitaet Karlsruhe (TH), Germany.
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  *
  *   * Redistributions of source code must retain the above copyright
  *     notice, this list of conditions and the following disclaimer.
  *   * Redistributions in binary form must reproduce the above
  *     copyright notice, this list of conditions and the following
  *     disclaimer in the documentation and/or other materials provided
  *     with the distribution.
  *   * Neither the name of the Universitaet Karlsruhe (TH) nor the names
  *     of its contributors may be used to endorse or promote products
  *     derived from this software without specific prior written
  *     permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **/

/*
 * these definitions are placed in this separate file so is possible to
 * replace them by CCS-style definitions if needed.
 */

#ifndef  __SDCC_DEFS_H__
#define  __SDCC_DEFS_H__

#define PIN(...)		__VA_ARGS__
#define INT(src)		src

/* enable access to TRISA and LATA */
#define TRISPORTA TRISA
#define LATPORTA LATA
#define PORTPORTA PORTA
/* enable access to TRISB and LATB */
#define TRISPORTB TRISB
#define LATPORTB LATB
#define PORTPORTB PORTB
/* enable access to TRISC and LATC */
#define TRISPORTC TRISC
#define LATPORTC LATC
#define PORTPORTC PORTC
/* enable access to TRISD and LATD */
#define TRISPORTD TRISD
#define LATPORTD LATD
#define PORTPORTD PORTD
/* enable access to TRISE and LATE */
#define TRISPORTE TRISE
#define LATPORTE LATE
#define PORTPORTE PORTE
/* enable access to TRISF and LATF */
#define TRISPORTF TRISF
#define LATPORTF LATF
#define PORTPORTF PORTF
/* enable access to TRISG and LATG */
#define TRISPORTG TRISG
#define LATPORTG LATG
#define PORTPORTG PORTG
/* enable access to TRISH and LATH */
#define TRISPORTH TRISH
#define LATPORTH LATH
#define PORTPORTH PORTH
/* enable access to TRISJ and LATJ */
#define TRISPORTJ TRISJ
#define LATPORTJ LATJ
#define PORTPORTJ PORTJ

#endif // __SDCC_DEFS_H__
