/**
  * Copyright (c) 2004, Telecooperation Office (TecO),
  * Universitaet Karlsruhe (TH), Germany.
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  *
  *   * Redistributions of source code must retain the above copyright
  *     notice, this list of conditions and the following disclaimer.
  *   * Redistributions in binary form must reproduce the above
  *     copyright notice, this list of conditions and the following
  *     disclaimer in the documentation and/or other materials provided
  *     with the distribution.
  *   * Neither the name of the Universitaet Karlsruhe (TH) nor the names
  *     of its contributors may be used to endorse or promote products
  *     derived from this software without specific prior written
  *     permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **/

/*
 *
 * Date:
 *  2005_02_01 Daniel & Raphael
 *  new Particle Base System organization
 *
 */


#include "app.h"
#include "rf.h"
#include "acl.h"


//****************************************************************************************************************
//*************              APP, SERVICES, REST
//****************************************************************************************************************


uint8_t AppSelfTest(uint8_t* result) wparam { return 0; }		//runs the selftest if a selftest connector is on

void AppSetLEDBehaviour(uint8_t ledstyle) wparam
{
	rf_LED_style=ledstyle;
	if (ledstyle==LEDS_OFF)
	{
		PCLedBlueOff();
		PCLedRedOff();
	}

}


// this function is called at slot end and handles the leds
void AppSetLEDs()
{
	if (rf_LED_style==LEDS_OFF)
	{
		//PCLedBlueOff();
		//PCLedRedOff();
	}
	if (rf_LED_style)										// if any other mode, then blinking led works at least
	{
		if (bit_test(rf_slotcounter,1)) PCLedRedOn(); else PCLedRedOff();				// this is for alife sign "blinking"
	}
	if (rf_LED_style==LEDS_NORMAL)
	{
		if (rf_sync_state==SYNC_STATE_SYNCED) PCLedBlueOn(); else PCLedBlueOff();		// this is for sync sign
	}
	if (rf_LED_style==LEDS_ON_RECEIVE)
	{
		if (LLDataIsNew()) PCLedBlueOn(); else PCLedBlueOff();		// this is for sync sign
	}
	if (rf_LED_style==LEDS_ON_SEND)
	{
		if (ACLSentPacketInThisSlot()) PCLedBlueOn(); else PCLedBlueOff();		// this is for sync sign
	}
	if (rf_LED_style==LEDS_ON_CRC_ERROR)
	{
		switch (LL_last_data)
		{
			case LL_GOOD:
				PCLedBlueOn();
				PCLedRedOff();
			break;
			case LL_ACM:
				PCLedBlueOn();
				PCLedRedOff();
			break;
			case LL_CRC_ERROR:
				PCLedBlueOff();
				PCLedRedOn();
			break;
			default:
				PCLedBlueOff();
				PCLedRedOff();
			break;
		}
 	}


}



  
  
