#ifndef __APP_H__
#define __APP_H__
/**
  * Copyright (c) 2004, Telecooperation Office (TecO),
  * Universitaet Karlsruhe (TH), Germany.
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  *
  *   * Redistributions of source code must retain the above copyright
  *     notice, this list of conditions and the following disclaimer.
  *   * Redistributions in binary form must reproduce the above
  *     copyright notice, this list of conditions and the following
  *     disclaimer in the documentation and/or other materials provided
  *     with the distribution.
  *   * Neither the name of the Universitaet Karlsruhe (TH) nor the names
  *     of its contributors may be used to endorse or promote products
  *     derived from this software without specific prior written
  *     permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **/

#include "../boards/coreboard.h"


// for LED
#define LEDS_NORMAL		1
#define LEDS_OFF		0		//leds off and stack doesnt touch them
#define LEDS_ON_SEND	2
#define LEDS_ON_RECEIVE	3
#define LEDS_ONLY_ONE	5
#define LEDS_ON_CRC_ERROR	6	// blue led on crc error



/*
 * no implementation found
 *
   void AppSetRealTimeClock(uint16_t value) wparam;		//sets the real time clock to given value
   uint8_t AppGetRealTimeClockH();				//returns the HIGh byte of the real time clock
   uint8_t AppGetSupplyVoltage();				//returns the supply voltage; 255 means 3.0 V, scaled linear
*/


void AppSetLEDBehaviour(uint8_t ledstyle) wparam;		//sets how LED should behave (blicking, blue on transmit, sync etc, off)
void AppSetLEDs();						//internal: updates the state of the LEDs
uint8_t AppSelfTest(uint8_t* result) wparam;		        //runs the selftest if a selftest connector is on


#endif //  __APP_H__
