/**
  * Copyright (c) 2004, Telecooperation Office (TecO),
  * Universitaet Karlsruhe (TH), Germany.
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  *
  *   * Redistributions of source code must retain the above copyright
  *     notice, this list of conditions and the following disclaimer.
  *   * Redistributions in binary form must reproduce the above
  *     copyright notice, this list of conditions and the following
  *     disclaimer in the documentation and/or other materials provided
  *     with the distribution.
  *   * Neither the name of the Universitaet Karlsruhe (TH) nor the names
  *     of its contributors may be used to endorse or promote products
  *     derived from this software without specific prior written
  *     permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **/


#ifndef __RTC_H__
#define __RTC_H__
/**
* Driver for real time clock in the new hardware layout (external timer3)
*
* Author: Christian Decker (cdecker@teco.edu)
* Date: 2003-06-10 (yyyy-mm-dd)
*
* Current state: template
*/

#include "../boards/coreboard.h"
#include "acl.h"

#define REAL_TIME_CLOCK


void RTCInit();
void RTCSetClock( uint8_t hour, uint8_t minute, uint8_t second, uint16_t millisecond ) wparam;
void RTCSetDate( uint8_t day, uint8_t month, uint8_t year ) wparam;
void RTCGetClock( uint8_t* hour, uint8_t* minute, uint8_t* second, uint16_t* millisecond ) wparam;
void RTCGetDate( uint8_t* day, uint8_t* month, uint8_t* year ) wparam;
uint8_t RTCGetTimeFromServer();
void RTCAddTimeStampACL();
void RTCAddTimeStampSpecificACL( uint8_t chose_data ) wparam;

void RTCUpdate();

uint16_t RTCGetMillisecond();
uint8_t RTCGetMonth();
uint8_t RTCGetYear();

void RTCSetMillisecond( uint16_t millisec ) wparam;
void RTCSetMonth( uint8_t mon ) wparam;
void RTCSetYear( uint8_t yea ) wparam;
void RTCIncYear();


#endif // __RTC_H__
