#ifndef __SDJS_H__
#define __SDJS_H__

/**
  * Copyright (c) 2004, Telecooperation Office (TecO),
  * Universitaet Karlsruhe (TH), Germany.
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  *
  *   * Redistributions of source code must retain the above copyright
  *     notice, this list of conditions and the following disclaimer.
  *   * Redistributions in binary form must reproduce the above
  *     copyright notice, this list of conditions and the following
  *     disclaimer in the documentation and/or other materials provided
  *     with the distribution.
  *   * Neither the name of the Universitaet Karlsruhe (TH) nor the names
  *     of its contributors may be used to endorse or promote products
  *     derived from this software without specific prior written
  *     permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **/

#include <tools.h>

#define SDJS_USED 001

// functions
void SDJSInit();
void SDJSRun();
void SDJSConfigure( uint8_t* config_data, uint8_t number_config_data ) wparam;
void SDJSConfigureValues( uint8_t type, uint8_t evoke, uint8_t led, uint8_t symbol, uint8_t fieldstrength, uint8_t probability_1, uint8_t value_1_min, uint8_t value_1_max, uint8_t probability_2, uint8_t value_2, uint8_t probability_3, uint8_t value_3, uint8_t probability_4, uint8_t value_4, uint8_t value_5, uint8_t value_6, uint8_t value_7 ) wparam;
void SDJSConfigureBigSlots( uint8_t first_value, uint8_t number_big_slots, uint8_t number_random_slots, uint8_t value ) wparam;
boolean SDJSDataIsNew();
void SDJSSetDataToOld();
void SDJSAnswerRequest( uint8_t* parameters ) wparam;
void SDJSSetSends();
void SDJSEvoke();
void SDJSRF();
uint8_t SDJSRFGetRandomRange( uint8_t min, uint8_t max ) wparam;




// SDJS globals.
extern boolean sdjs_start;                                   // is set if sdjs start command is found either in received data or in own sendbuffer. if found set SDJSRF() is executed at a later point.
extern uint8_t sdjs_type;                               // determines type of sdjs that is executed. at the moment there's only type 1, type 0 means no sdjs is executed.


#endif // __SDJS_H__
